#include <stdio.h>
#include <windows.h>
#include <winioctl.h>
#include <stdlib.h>
#include <string.h>

#define SIOCTL_TYPE 40000

#define IOCTL_HELLO\
    CTL_CODE( SIOCTL_TYPE, 0x800, METHOD_BUFFERED, FILE_READ_DATA|FILE_WRITE_DATA)
#define IOCTL_HIDE\
    CTL_CODE( SIOCTL_TYPE, 0x801, METHOD_BUFFERED, FILE_READ_DATA|FILE_WRITE_DATA)

int __cdecl main(int argc, char* argv[])
{
    HANDLE hDevice;
    DWORD NombreByte;
    char *sayhello = "Hi! From UserLand" , out[50];

	// Fills the array 'out' by zeros
    ZeroMemory(out,sizeof(out));

	// Opens our Device
    hDevice = CreateFile("\\\\.\\myDevice",GENERIC_WRITE|GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
    printf("Handle pointer: %p\n",hDevice);
    // We send a CTL command to read our message in kernel
	if (argc > 1)
      DeviceIoControl(hDevice,IOCTL_HIDE,argv[1],strlen(argv[1]),out,sizeof(out),&NombreByte,NULL);
	else
	{
	  DeviceIoControl(hDevice,IOCTL_HELLO,sayhello,strlen(sayhello),out,sizeof(out),&NombreByte,NULL);
      printf("Message from the kernelLand : %s\n",out);
	}
	
    CloseHandle(hDevice); // Close the handle: We should observe the function CloseFunction is called
    return 0;
}